package com.fs.hisStore.mapper;

import java.util.List;
import java.util.Set;

import com.fs.hisStore.domain.FsUserCourseCountScrm;
import com.fs.hisStore.vo.FsUserLastCount;
import org.apache.ibatis.annotations.Param;

/**
 * 用户看课统计Mapper接口
 *
 * @author fs
 * @date 2025-04-02
 */
public interface FsUserCourseCountScrmMapper
{
    /**
     * 查询用户看课统计
     *
     * @param id 用户看课统计ID
     * @return 用户看课统计
     */
    public FsUserCourseCountScrm selectFsUserCourseCountById(Long id);

    /**
     * 查询用户看课统计列表
     *
     * @param fsUserCourseCount 用户看课统计
     * @return 用户看课统计集合
     */
    public List<FsUserCourseCountScrm> selectFsUserCourseCountList(FsUserCourseCountScrm fsUserCourseCount);

    /**
     * 新增用户看课统计
     *
     * @param fsUserCourseCount 用户看课统计
     * @return 结果
     */
    public int insertFsUserCourseCount(FsUserCourseCountScrm fsUserCourseCount);

    /**
     * 修改用户看课统计
     *
     * @param fsUserCourseCount 用户看课统计
     * @return 结果
     */
    public int updateFsUserCourseCount(FsUserCourseCountScrm fsUserCourseCount);

    /**
     * 删除用户看课统计
     *
     * @param id 用户看课统计ID
     * @return 结果
     */
    public int deleteFsUserCourseCountById(Long id);

    /**
     * 批量删除用户看课统计
     *
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteFsUserCourseCountByIds(Long[] ids);

    FsUserCourseCountScrm findByUserId(@Param("userId") Long userId);

    /**
     * 获取看课统计表结果
     * @return list
     */
    List<FsUserCourseCountScrm> getCountResult();

    /**
     * 获取最近七天每天最大心跳时间的看课记录数据
     * @return
     */
    List<FsUserCourseCountScrm> getUserStatusAndLastWatchDate();

    /**
     * 往看课统计表中插入数据
     */
    void insertFsUserCourseCountTask(FsUserCourseCountScrm fsUserCourseCount);

    /**
     * 查询会员最新的看课状态和心跳时间
     * @return
     */
    List<FsUserLastCount> selectUserLastCount(@Param("userIds") Set<Long> userIds);

}
